@x
% This file is part of the MMIXware package (c) Donald E Knuth 1999
@i boilerplate.w %<< legal stuff: PLEASE READ IT BEFORE MAKING ANY CHANGES!
@y
% This file is part of the MMIXware package (c) Donald E Knuth 1999
@i boilerplate.w %<< legal stuff: PLEASE READ IT BEFORE MAKING ANY CHANGES!
@i win32typ.w
@z

@x
  return &p->dat[offset>>2];
@y
  if((addr.h == START_VRAM_H) && !Painting)
    InvalidateRect(hwnd, &rect, 0);
  return &p->dat[offset>>2];
@z

@q identifier mm has to be changed due to name conflicts with windows types
@x
@d mm 0x98 /* the escape code of \.{mmo} format */
@y
@d mmesc 0x98 /* the escape code of \.{mmo} format */
@z

@x
if (buf[0]!=mm || buf[1]!=lop_pre) mmo_err;
@y
if (buf[0]!=mmesc || buf[1]!=lop_pre) mmo_err;
@z

@x
 loop:@+if (buf[0]==mm) switch (buf[1]) {
@y
 loop:@+if (buf[0]==mmesc) switch (buf[1]) {
@z

@x
   if (buf[0]==mm) {
@y
   if (buf[0]==mmesc) {
@z

@x
@* Running the program. Now we are ready to fit the pieces together into a
working simulator.
@y
@* Windows Stuff.
We need some additional stuff for opening a graphics window and for preparing MMIX 
to paint into it. Furthermore, we add some dialogs to set up parameters for the simulation.
@ First, we have to define the Window. The screen width should be a multiple of 32
(|tetra|-alignment).
@d SCREEN_WIDTH 320
@d SCREEN_HEIGHT 240
@d FIELD_SIZE ((SCREEN_WIDTH*SCREEN_HEIGHT)/32)
@d START_VRAM_H 0x50000000
@d START_VRAM_L 0x00000000

@ @<Global variables@>+=
HDC Ghdc; //Handle to the Graphics device context
HANDLE hThread;//Handle to the simulator thread
HANDLE hEvt;//Synchronisation object for VRam access
HWND hwnd ;//Handle for graphics window
RECT rect;
HINSTANCE hInst;//current instance
tetra VRam[FIELD_SIZE];//That's for the simulated Video RAM
int Painting = 0;//flag for synchronizing access to video RAM

@ Initially the video RAM has to be set to zero
@<Subroutines@>+=
void init_VRam @,@,@[ARGS((void))@];@+@t}\6{@>
void init_VRam()
{
  int i;
  for(i=0; i<FIELD_SIZE; i++) VRam[i] = 0;
}

@ @<Initialize everything@>+=
init_VRam();

@ A tricky part is redirection of console I/O. That's from an article from 
Girish Bharadwaj at codeguru.developer.com./misc/console.shtml
@<Subroutines@>+=
void RedirectIO()
{
    int                        hConHandle;
    long                       lStdHandle;
    CONSOLE_SCREEN_BUFFER_INFO coninfo;
    FILE                       *fp;
    if(!AllocConsole()) {
     MessageBox(NULL, "Could not open Console", "Exiting", MB_OK);
     exit(-1);
    }
    SetConsoleTitle("MMIX");
    lStdHandle = (long)GetStdHandle(STD_OUTPUT_HANDLE);@/@,

    // set the screen buffer to be big enough to let us scroll text
    GetConsoleScreenBufferInfo((HANDLE)lStdHandle,&coninfo);@/@,

    // redirect unbuffered STDOUT to the console
    hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
    fp = fdopen( hConHandle, "w" );
    *stdout = *fp;
    setvbuf( stdout, NULL, _IONBF, 0 );@/@,

    // redirect unbuffered STDIN to the console
    lStdHandle = (long)GetStdHandle(STD_INPUT_HANDLE);
    hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
    fp = _fdopen( hConHandle, "r" );
    *stdin = *fp;
    setvbuf( stdin, NULL, _IONBF, 0 );@/@,

    // redirect unbuffered STDERR to the console
    lStdHandle = (long)GetStdHandle(STD_ERROR_HANDLE);
    hConHandle = _open_osfhandle(lStdHandle, _O_TEXT);
    fp = _fdopen( hConHandle, "w" );
    *stderr = *fp;
    setvbuf( stderr, NULL, _IONBF, 0 );
}

@ The command line comes as a single string in Windows. It has to become 
separated in single argument values for |argv|. The alternative is to open dialogs.
To this end, |argc| and |argv| become global variables. 
@ @d MAX_ARGS 25
@<Global...@>+=
char *argv[MAX_ARGS] = {"mmixwin"};
int argc = 1;

@ @<Sub...@>+=
void prepare_args(LPSTR cmdline)
{ char cmdbuffer[256];
  for(argc=1; sscanf(cmdline, "%s", cmdbuffer) && *cmdline; argc++){
   if(argc==MAX_ARGS-1){
     MessageBox(NULL, "Too many command line arguments", "Exiting", MB_OK);
     exit(-1);
   }
   argv[argc] = (char*)malloc(strlen(cmdbuffer)+1);
   strcpy(argv[argc], cmdbuffer);
   cmdline += strlen(cmdbuffer);
   while(isspace(*cmdline)) cmdline++;
  }
  argv[argc] = NULL;
}

@ At startup the user shall be asked for a .mmo-file to run.
So we need some additional global variables and will open a dialog.
@<Global...@>+=
char InputFileName[_MAX_PATH];
OPENFILENAME ofn;

@ @<GetInputFileName@>+=
  ofn.lStructSize = sizeof(OPENFILENAME);
  ofn.hwndOwner = hwnd;
  ofn.hInstance = NULL;
  ofn.lpstrFilter = "MMO-Files (*.MMO)\0*.mmo\0";
  ofn.lpstrCustomFilter = NULL;
  ofn.nMaxCustFilter = 0;
  ofn.nFilterIndex = 0;
  ofn.lpstrFile = InputFileName;
  ofn.nMaxFile = _MAX_PATH;
  ofn.lpstrFileTitle = NULL;
  ofn.nMaxFileTitle = _MAX_FNAME + _MAX_EXT;
  ofn.lpstrInitialDir = NULL;
  ofn.lpstrTitle = NULL;
  ofn.Flags = OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
  ofn.nFileOffset = 0;
  ofn.nFileExtension = 0;
  ofn.lpstrDefExt = "mmo";
  ofn.lCustData = 0L;
  ofn.lpfnHook = NULL;
  ofn.lpTemplateName = NULL;
  GetOpenFileName(&ofn);

 
@ @<Prepare the command line arguments@>=
if(!strlen(lpszCmdParam)){
  @<GetInputFileName@>;
  DialogBox(hInst, "INITDLG", hwnd, (DLGPROC)SetOptions);
  argv[argc++] = InputFileName;
  argv[argc] = NULL;
}
else prepare_args(lpszCmdParam);

@ This routine will paint the bitmap into the window. It can only start after 
the synchronisation object has been signaled by the simulator thread (see below). 
Once having been signaled, it will remain in that state. 
We have to take care for changing little to big endian....
@<Subroutines@>+=
void Paint(int xl, int yo, int xr, int yu)
{ octa vaddr;
  unsigned int count, bit;
  HBITMAP hBitmap = CreateBitmap(SCREEN_WIDTH, SCREEN_HEIGHT, 1, 1, VRam);
  HDC memDC = CreateCompatibleDC(Ghdc);
  mem_tetra *tt;
  vaddr.h = START_VRAM_H;
  WaitForSingleObject(hEvt, INFINITE);
  Painting = 1;
  for(count=0; count<FIELD_SIZE; count++){
    vaddr.l = count<<2;
    tt = mem_find(vaddr);
    if(!tt->tet) {VRam[count] = 0;continue;}
    for(bit=0; bit<32; bit++)
      VRam[count] |= (((tt->tet)&(1<<bit))<<(31-bit))>>bit;
  }
  Painting = 0;
  SelectObject(memDC, hBitmap);
  BitBlt(Ghdc, 0, 0, 320, 240, memDC, 0, 0, SRCCOPY);
}

@* Running the program. Now we are ready to fit the pieces together into a
working simulator.
@z

@x
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
#include "abstime.h"
@<Preprocessor macros@>@;
@<Type declarations@>@;
@<Global variables@>@;
@<Subroutines@>@;
@y
#include <windows.h>
#include <stdio.h>
#include <fcntl.h>
#include <wincon.h>
#include <stdlib.h>
#include <io.h>
#include <ctype.h>
#include <string.h>
#include <signal.h>
#include <process.h>
#include "resource.h"
#include "abstime.h"
@<Preprocessor macros@>@;
@<Type declarations@>@;
@<Global variables@>@;
@<Subroutines@>@;
@<The main MMIX-Thread@>@;
@<Windows Call backers@>;
@z

@x
main(argc,argv)
  int argc;
  char *argv[];
@y
int APIENTRY WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
{ 
  static char szAppName[] = "MMIX-Win" ;
  MSG         msg ;
  WNDCLASS    wndclass ;
int i;
  
  RedirectIO();
  hEvt = CreateEvent(NULL, TRUE, FALSE, "VRE");
  @<Prepare the command line arguments@>;
  if (!hPrevInstance)
  { wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
    wndclass.lpfnWndProc   = WndProc ;
    wndclass.cbClsExtra    = 0 ;
    wndclass.cbWndExtra    = 0 ;
    wndclass.hInstance     = hInstance ;
    wndclass.hIcon         = LoadIcon(NULL,IDI_APPLICATION);
    wndclass.hCursor       = LoadCursor(NULL,IDC_ARROW);
    wndclass.hbrBackground = GetStockObject(WHITE_BRUSH);
    wndclass.lpszMenuName  = NULL ;
    wndclass.lpszClassName = szAppName ;
    RegisterClass (&wndclass) ; }
    hInst = hInstance; 
  hwnd = CreateWindow (szAppName,        //Fensterklassenname
                    szAppName, //Titelleiste
                    WS_CAPTION, //Fensterstil
                    CW_USEDEFAULT,       //Fensterpos, x
                    CW_USEDEFAULT,       //Fensterpos., y 
                    SCREEN_WIDTH,       //horizontal size
                    SCREEN_HEIGHT,       //vertical size
                    NULL,                //Parent Window
                    NULL,                //Handle Menue
                    hInstance,           //Handle to instance 
                    NULL) ;              //Special parameter
  ShowWindow (hwnd, nCmdShow) ;
  UpdateWindow (hwnd) ;
  
  while (GetMessage (&msg, NULL, 0, 0))
          { TranslateMessage (&msg) ;
            DispatchMessage (&msg) ; }
  return msg.wParam ;
}

@ We need one call backer for the main window:
@<Win...@>+=
LRESULT CALLBACK WndProc (HWND hwnd, UINT message, 
                                 UINT wParam, LONG lParam)
{ PAINTSTRUCT ps; 
  DWORD dwThreadId;

  switch (message)
  { case WM_PAINT :
      Ghdc = BeginPaint (hwnd, &ps) ;
      GetClientRect (hwnd, &rect) ;
      Paint(rect.left, rect.top, rect.right, rect.bottom);
      EndPaint (hwnd, &ps) ;
      return 0 ;
    case WM_CREATE:
      hThread = CreateThread(0, 0, (LPTHREAD_START_ROUTINE)ThreadProcedure, 
          0, 0, &dwThreadId);
      return 0;
    case WM_DESTROY : PostQuitMessage (0) ; return 0 ;
  }
  return DefWindowProc (hwnd, message, wParam, lParam) ;
}


@ The next call back routine handles the dialog that replaces the command line options, 
if the command line does not contain any. 
Not sure whether it is worth, doing more here...
@<Win...@>+=
LRESULT CALLBACK SetOptions(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  switch(iMsg){
    case WM_COMMAND:
      switch(LOWORD(wParam)){
         case IDOK: 
                    if(IsDlgButtonChecked(hDlg, IDC_r))
                    argv[argc++] = "-r";
                    if(IsDlgButtonChecked(hDlg, IDC_s))
                    argv[argc++] = "-s";
                    if(IsDlgButtonChecked(hDlg, IDC_P))
                    argv[argc++] = "-P";
                    if(IsDlgButtonChecked(hDlg, IDC_V))
                    argv[argc++] = "-v";
                    if(IsDlgButtonChecked(hDlg, IDC_Q))
                    argv[argc++] = "-q";
                    if(IsDlgButtonChecked(hDlg, IDC_I))
                    argv[argc++] = "-i";
                    if(IsDlgButtonChecked(hDlg, IDC_I2))
                    argv[argc++] = "-I";
                    EndDialog(hDlg, TRUE);
                    return TRUE;
          default:  return FALSE;
      }
    default: return FALSE;
  }
}

@ The old |main|-function now becomes a thread.
@<The main...@>=
DWORD WINAPI ThreadProcedure(LPWORD lpdwData)
@z

@x
  @<Initialize everything@>;
@y
  @<Initialize everything@>;
  SetEvent(hEvt);//now |Paint| can access memory
@z

@x
  if (interacting || profiling || showing_stats) show_stats(true);
@y
  if (interacting || profiling || showing_stats) show_stats(true);
  exit(0);
  ExitThread(0);
@z


